import Ajv = require('ajv');
import { SecretLintConfigDescriptor } from '@secretlint/types';
export declare const ajv: Ajv.Ajv;
export { SecretLintConfigDescriptor };
export declare const SecretLintConfigDescriptorSchema: {
    $schema: string;
    definitions: {
        Options: {
            $ref: string;
        };
        Options_1: {
            $ref: string;
        };
        SecretLintRuleCreator: {
            $ref: string;
        };
        SecretLintRuleLocalizeMessages: {
            $ref: string;
        };
        SecretLintRulePresetCreator: {
            $ref: string;
        };
        SecretLintRuleSeverityLevel: {
            description: string;
            enum: string[];
            type: string;
        };
        SecretlintCoreSharedOptions: {
            $ref: string;
        };
        __type: {
            additionalProperties: {};
            type: string;
        };
        __type_1: {
            properties: {};
            type: string;
        };
        __type_2: {
            properties: {
                messages: {
                    $ref: string;
                };
                meta: {
                    properties: {
                        docs: {
                            properties: {
                                url: {
                                    type: string;
                                };
                            };
                            required: string[];
                            type: string;
                        };
                        id: {
                            type: string;
                        };
                        recommended: {
                            type: string;
                        };
                        supportedContentTypes: {
                            items: {
                                enum: string[];
                                type: string;
                            };
                            type: string;
                        };
                        type: {
                            enum: string[];
                            type: string;
                        };
                    };
                    required: string[];
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        __type_3: {
            additionalProperties: {
                allOf: ({
                    $ref: string;
                    type?: undefined;
                } | {
                    type: string;
                    $ref?: undefined;
                })[];
            };
            type: string;
        };
        __type_4: {
            properties: {};
            type: string;
        };
        __type_5: {
            properties: {
                meta: {
                    properties: {
                        docs: {
                            properties: {
                                url: {
                                    type: string;
                                };
                            };
                            required: string[];
                            type: string;
                        };
                        id: {
                            type: string;
                        };
                        recommended: {
                            type: string;
                        };
                        type: {
                            enum: string[];
                            type: string;
                        };
                    };
                    required: string[];
                    type: string;
                };
            };
            required: string[];
            type: string;
        };
        "{[x:string]:SecretLintRuleLocalizeMessageHandler<any>;}": {
            type: string;
        };
    };
    properties: {
        rules: {
            items: {
                anyOf: ({
                    properties: {
                        allowMessageIds: {
                            description: string;
                            items: {
                                type: string;
                            };
                            type: string;
                        };
                        disabled: {
                            description: string;
                            type: string;
                        };
                        id: {
                            description: string;
                            type: string;
                        };
                        options: {
                            $ref: string;
                            description: string;
                        };
                        rule: {
                            $ref: string;
                            description: string;
                        };
                        severity: {
                            $ref: string;
                            description: string;
                        };
                        rules?: undefined;
                    };
                    required: string[];
                    type: string;
                } | {
                    properties: {
                        disabled: {
                            description: string;
                            type: string;
                        };
                        id: {
                            description: string;
                            type: string;
                        };
                        options: {
                            $ref: string;
                            description: string;
                        };
                        rule: {
                            $ref: string;
                            description: string;
                        };
                        rules: {
                            description: string;
                            items: {
                                properties: {
                                    allowMessageIds: {
                                        description: string;
                                        items: {
                                            type: string;
                                        };
                                        type: string;
                                    };
                                    disabled: {
                                        description: string;
                                        type: string;
                                    };
                                    id: {
                                        description: string;
                                        type: string;
                                    };
                                    options: {
                                        $ref: string;
                                        description: string;
                                    };
                                    rule: {
                                        $ref: string;
                                        description: string;
                                    };
                                    severity: {
                                        $ref: string;
                                        description: string;
                                    };
                                };
                                required: string[];
                                type: string;
                            };
                            type: string;
                        };
                        allowMessageIds?: undefined;
                        severity?: undefined;
                    };
                    required: string[];
                    type: string;
                })[];
            };
            type: string;
        };
        sharedOptions: {
            $ref: string;
        };
    };
    required: string[];
    type: string;
};
export declare type ValidateFunction<T> = ((data: unknown) => data is T) & Pick<Ajv.ValidateFunction, 'errors'>;
export declare const isSecretLintConfigDescriptor: ValidateFunction<SecretLintConfigDescriptor>;
export default function validate(value: unknown): SecretLintConfigDescriptor;
